/*global$GH*/
/**
 * 描述: 通用搜索
 * 时间：2017年1月
 */
(function() {
    var Main = {
        scroll: null,
        cacheHistory: [],
        searchType: "",
        timestamp: "",//点击上报的时候的一个时间戳
        randomnum: "",//点击上报的时候的一个随机数，给app的

        /**
         * 初始化
         * @return {[type]} [description]
         */
        init: function() {
            var me = this;
             var pathname = location.pathname;
            this.initSearchBar();
            // 初始化滚动
            this.scroll = $GH.iScroll('#J_SearchEmbed  .J_ListScroll', {
                top: $('#J_SearchBox').height() - $('#gh').height(),
                zIndex: 999
            },{
                disablePointer: true,
                disableTouch: false,
                disableMouse: false
            });
            // 滑动的时候取消输入框焦点
            $('.J_ListScroll').on('touchmove', function() {
                $('#J_Keyword').blur();
            });

            //历史搜索
            $(document).on('click','#J_SearchEmbed  .J_HistoryList li', function() {
                var content = $(this).text();
                var city = $(this).data('city');
                var monitorName = $('.J_HistoryList').data('monitor');
                var clickRank = $(this).index();
                me.searchType = "search_query";
                me.randomnum = parseInt(Math.random() * 10000 + 1);
                me.timestamp = new Date().getTime();
                me.redirect(content);
            });
            //联想搜索
            $(document).on('click', '#J_SearchEmbed  .J_SuggestList li', function() {
                var content = $(this).text();
                var city = $(this).data('city');
                me.searchType = "search_ideapad";
                me.randomnum = parseInt(Math.random() * 10000 + 1);
                me.timestamp = new Date().getTime();
                var clickRank = $(this).index();
                me.redirect(content);

            });

            // 清除搜索历史
            $('.J_ClearHistory').on('click', function() {
                me.clearHistory();
                $('#J_Keyword').focus();
            });


            // trigger search bar
            $("#J_SearchBox .J_Input").on('click', function() {
            	
            	/*mui.plusReady(function(){
					mui.openWindow({
								url: "searchWebview.html",
								id: "target",
								extras:{
									//targetUrl: operation.nowTarget
								},
								show:{
								    autoShow:true,//页面loaded事件发生后自动显示，默认为true
								    aniShow:"slide-in-right"//页面显示动画，默认为”slide-in-right“；
								},
								waiting:{
								    autoShow:true,//自动显示等待框，默认为true
								    title:"正在加载..."//等待对话框上显示的提示内容
								}
					});
			
				});*/
				

               $('#J_SearchBar').show();
                $("#J_SearchBox").hide();
                $('#J_Keyword').focus();
                $("#J_SearchEmbed").addClass("opening");
                $('body').css('overflow','hidden');
                me.scroll.refresh();
                if ($('#J_SearchAddress').length) {
                    me.checkLocation();
                } 
            });

            // 延时加载历史记录
            setTimeout(function() {
                me.showHistory($.trim($('#J_Keyword').val()), function() {
                    me.loadSuggest();
                });
            }, 1000);
            // 默认搜索词
            this.defaultWord();
            // 热门搜索词
            this.hotWord();
            this.switchAddress();
        },
        defaultWord: function() {
            var me = this;
            var type = $('#J_Keyword').data('defword-type');
            var pathname = location.pathname;
            if (pathname != '/search') {
                try {
                    sessionStorage.setItem("_WY_Search_WordDoc", '');
                    sessionStorage.setItem("_WY_Search_Word", '')
                } catch (e) {}
            }
            if (type) {
                $.ajax({
                    type: 'GET',
                    url: $GC.wyServer + '/json/white/h5search/defaultWord',
                    dataType: "json",
                    data: {
                        hotType: type
                    },
                    success: function(res) {
                        var data = res.data;
                        if (!res.hasError && data) {
                            var wordDoc = data.wordDoc;
                            var searchWord = data.searchWord;
                            if (wordDoc) {
                                $('.J_SearchWord').text(wordDoc);
                                $('#J_Keyword').attr('placeholder', wordDoc);
                            }
                            try {
                                sessionStorage.setItem("_WY_Search_WordDoc", wordDoc || '');
                                sessionStorage.setItem("_WY_Search_Word", searchWord || '')
                            } catch (e) {}
                        }
                    }
                });
            } else {
                try {
                    var wordDoc = sessionStorage.getItem("_WY_Search_WordDoc");
                    if (wordDoc) {
                        $('#J_Keyword').attr('placeholder', wordDoc);
                    }
                } catch (e) {}
            }
        },
        hotWord: function() {
            var me = this;
            var type = $('#J_SearchHot').data('type');
            var monitorName = $('#J_SearchHot').data('monitor');
            if (type) {
                $.ajax({
                    type: 'GET',
                    url: $GC.wyServer + '/json/white/h5search/hotWord',
                    dataType: "json",
                    data: {
                        hotType: type
                    },
                    success: function(res) {
                        var data = res.data;
                        if (!res.hasError && data) {
                            var html = '';
                            var html = data.map(function(item) {
                                return '<li data-url="'+item.h5Url+'">'+item.hotWord+'</li>'
                            }).join('');
                            if (html) {
                                $('#J_SearchHot').show();
                                $('#J_SearchHot ul').html(html);
                                try {
                                    sessionStorage.setItem("_WY_Search_Hot", html);
                                } catch (e) {}
                            }
                        }
                    }
                });
            } else {
                try {
                    var searchHot = sessionStorage.getItem("_WY_Search_Hot");
                    if (searchHot) {
                        $('#J_SearchHot').show();
                        $('#J_SearchHot ul').html(searchHot);
                    }
                } catch (e) {}
            }
            $(document).on('click','#J_SearchHot li', function() {
                var content = $(this).text();
                var url = $(this).data('url');
                var city = $('#J_CurrentAddress').text();
                me.randomnum = parseInt(Math.random() * 10000 + 1);
                me.timestamp = new Date().getTime();
                var index = $(this).index();
                if (url) {
                    location.href = url;
                } else {
                    me.redirect(content);
                }
            });
        },
        checkLocation: function() {
            var me = this;
            // 先从cookie里获取定位信息
            var locsCookie = $.cookies('_locs'),
                cityId = 'all',
                city = '全国';
            if (locsCookie) {
                var locs = locsCookie.split("||"),
                    ids = locs[0].split("_"),
                    strs = locs[1].split("_"),
                    cityId = ids[1],
                    province = decodeURIComponent(strs[0]),
                    city = decodeURIComponent(strs[1]);
                if (locs[2]) {
                    coord = locs[2].split("_");
                    me.latitude = coord[0];
                    me.longitude = coord[1];
                }
            }
            if (city == '不限') {
                city = province;
            }
            $('#J_CurrentAddress').text(city);
            // 从cookie获取上次检测时间
            var lastCheckLocTime = $.cookies('_checkLocTime') || 0,
                nowTimestamp = Date.parse(new Date()) / 1000;
            $GH.locate(function(loc) {
                me.latitude = loc.latitude;
                me.longitude = loc.longitude;
                if (loc.city == '不限') {
                    loc.city = loc.province;
                }
                // 距上次检测定位不超过24小时，不再检测
                if (lastCheckLocTime && nowTimestamp - lastCheckLocTime < 24*60*60) {
                    return;
                }
                // 判断cookie里的定位和当前定位是否一致，不同则重新设置
                if (me.latitude && me.longitude && (cityId != loc.cityId || province != loc.province)) {
                    $.cookies('_checkLocTime', nowTimestamp, {
                        path: '/',
                        expires: 7
                    });
                    $GH.confirm('检测到您的当前定位：<span style="color:#3278ee">'+loc.city+'</span>是否切换?', [{
                        name: '取消',
                        style: 'btn',
                        fn: function(close) {
                            close();
                        }
                    }, {
                        name: '切换',
                        style: 'btn',
                        fn: function(close) {
                            close();
                            $('#J_CurrentAddress').text(loc.city);
                            // 切换后保存到cookie
                            $.cookies('_locs', loc.provinceId + '_' + loc.cityId + '||' + loc.province + '_' + loc.city, {
                                    path: '/',
                                    expires: 7
                                });
                        }
                    }]);
                }
            }, {
                cache: false,
                setCookie: false
            });
        },
        switchAddress: function() {
            var me = this;
            $('#J_SwitchAddress').on("click", function () {
                $('#J_Keyword').blur();
                $GH.selectCity.init(function(loc) {
                    if (loc.cityStr == '不限') {
                        loc.cityStr = loc.provinceStr;
                    }
                    $('#J_CurrentAddress').text(loc.cityStr);
                    // 保存到cookie
                    $.cookies('_locs', loc.provinceId + '_' + loc.cityId + '||' + loc.provinceStr + '_' + loc.cityStr, {
                            path: '/',
                            expires: 7
                        });
                    if (!me.latitude) {
                        $('.J_SubScroller ul li:eq(0)').remove();
                    }
                }, {
                    isGH: 0,
                    showHot: 1,
                    showAll: 1,
                    renderCallBack: function() {
                        if (!me.latitude) {
                            $('.J_SubScroller ul').prepend('<li class="disabled">无法定位当前位置</li>');
                        }
                    }
                });
            });
        },
        /**
         * 初始化搜索栏
         * @return {[type]} [description]
         */
        initSearchBar: function() {
            var me = this;
            $('#J_Keyword').focus();
            var defaultValue = $('#J_Keyword').val();
            // 光标定位到末尾
            if (defaultValue && defaultValue.length) {
                $('#J_Keyword')[0].selectionStart = $('#J_Keyword')[0].selectionEnd = defaultValue.length;
                $('.J_Clear').show();
            }

            function _close() {
                $('#J_SearchBar').hide();
                $("#J_SearchBox").show();
                $("#J_SearchEmbed").removeClass("opening");
                $('body').css('overflow','auto');
            }

            // 清除搜索输入框内容
            $('.J_Clear').on('click', function() {
                $('#J_Keyword').val('').focus();
                me.showHistory();
                return false;
            });
            // 搜索
            $('.J_Search').on('click', function() {
                var searchTxt = '';
                var monitor = $('#J_SearchForm').data('monitor');
                try {
                    var word = sessionStorage.getItem("_WY_Search_Word");
                    if (word) {
                        searchTxt = word;
                    }
                } catch (e) {}
                var txt = $('#J_Keyword').val() || searchTxt;
                me.randomnum = parseInt(Math.random() * 10000 + 1);
                me.timestamp = new Date().getTime();
                me.searchType = "search";
                me.redirect(txt);
                return false;
            });
            $('#J_SearchForm').on('submit', function(event) {
            
            	 var txt = $('#J_Keyword').val();
            	
                var monitor = $('#J_SearchForm').data('monitor');
                var searchTxt = '';
                try {
                    var word = sessionStorage.getItem("_WY_Search_Word");
                    if (word) {
                        searchTxt = word;
                    }
                } catch (e) {}
              var txt = $('#J_Keyword').val() || searchTxt;
              //  var profix = $GC.domainProfix;
                me.randomnum = parseInt(Math.random() * 10000 + 1);
                me.timestamp = new Date().getTime();

                me.searchType = "search";
                var searchTextVal =  me.redirect(txt);
                if(searchTextVal==''){
                	event.preventDefault();
                	return false;
                }
                
               // me.redirect(txt);
                return false;
            });

            // 取消搜索
            $('.J_Cancel').on('click', function() {
            	
                _close();
               
                $('#J_Keyword').val('');
            });

            // 输入框内容变化
            $('#J_Keyword').on('input focus', function() {
                var val = $.trim($(this).val());

                if (val) {
                    $('.J_Clear').show();
                    if(window.location.pathname=='/lecture/home'){
                        $('.J_Cancel').attr('monitor','weiyiclass_search_ideapad_ideapad')
                    }
                } else {
                    $('.J_Clear').hide();
                    if(window.location.pathname=='/lecture/home'){
                        $('.J_Cancel').attr('monitor','weiyiclass_search_ideapad_cancel')
                    }
                }
                $('.J_ListScroll').show();
                // 先显示历史记录，再处理搜索建议
                me.showHistory(val, function() {
                    me.loadSuggest();
                });
            });
        },
        /**
         * 关键词跳转
         * @param  {[type]} searchKey [description]
         * @return {[type]}           [description]
         */
        redirect: function(searchKey) {
        	//alert(2);
            var me = this;
            var hash = location.hash;
            searchKey = $.trim(searchKey);
          //  alert(searchKey);
            if(searchKey==null || searchKey==''){
            	
            	
            	$GH.alert('请输入搜索关键词');
            	return false;
            }
            if (!searchKey) {
                $GH.alert('请输入搜索关键词');
                return;
            }
            var _nowtarget = $('#J_Keyword').data('goto');
            var url =  _nowtarget + '?q=' + encodeURIComponent(searchKey);
            if ($('#J_HiddenHospital').length) {
                url += '&hospitalId=' + $('#J_HiddenHospital').val();
            }
            if (me.latitude && me.longitude) {
                url += '&lat=' + me.latitude + '&lon=' + me.longitude;
            }
            // 这块逻辑有点问题？
            if ($('#J_Keyword').data('city') === true) {
                var cityName = $('.J_Menu_Link span').text();
                if (cityName) {
                    url += '&cityname=' + cityName;
                }
            }

            //根据搜索类型，在URL中拼接类型和一个随机数，lize
            if(me.searchType !== ""){
                if(me.searchType === "search"){
                    url += "&searchType=search&searchRad=" + me.timestamp * 10000 + me.randomnum + "";
                }else if(me.searchType === "search_query"){
                    url += "&searchType=search_query&searchRad=" + me.timestamp * 10000 + me.randomnum + "";
                }else if(me.searchType === "search_ideapad"){
                    url += "&searchType=search_ideapad&searchRad=" + me.timestamp * 10000 + me.randomnum + "";
                }
            }
            if (hash) {
                url += hash;
            }
            // 如果不存在历史记录中，则需要新增到历史记录
            if (!this.isInHistory(searchKey)) {
                this.addHistory(searchKey, function() {
//                  if(typeof thisBridge == "object"){
                        operation.nowTarget = url;
//                      getUserInfo();
						searchInfo();
//                  }
                });
            } else {
//              if(typeof thisBridge == "object"){
                    operation.nowTarget = url;
                    searchInfo();
//                  getUserInfo();
//              }
            }
        },
        /**
         * 判断是否在历史记录中
         * @param  {[type]}  searchKey [description]
         * @return {Boolean}           [description]
         */
        isInHistory: function(searchKey) {
            var hs = this.cacheHistory;
            for (var i = 0; i < hs.length; i++) {
                if (hs[i] === searchKey) {
                    return true;
                }
            }
            return false;
        },
        /**
         * 加载搜索推荐词
         * @return {[type]} [description]
         */
        loadSuggest: function() {
            var $cur = $('#J_Keyword');
            if (!$cur.val()) {
                return;
            }
            var actionUrl = $.trim($cur.data('action'));
            if (!actionUrl) {
                return;
            }
            var me = this;
            $.ajax({
                type: 'get',
                dataType: 'json',
                cache: false,
                url: actionUrl,
                data: {
                    q: $cur.val(),
                    type: $cur.data('type')
                },
                success: function(re) {
                    if (!re) {
                        return;
                    }

                    var data = re.suggest || [];
                    if (!data) {
                        return;
                    }

                    me.showSuggest($cur.val(), data);
                },
                error: function(xhr, code) {
                    if (code === 'abort') {
                        return;
                    }
                    $GH.alert('操作失败，请稍后再试！');
                }
            });
        },
        /**
         * 显示搜索推荐词
         * @param  {[type]} list [description]
         * @return {[type]}      [description]
         */
        showSuggest: function(keyword, list) {
            var me = this;
            //打点
            var href = window.location.href;
            var monitor = "search_ideapad";
            var monitor_city = "";
            if (href.indexOf("/fastorder/hospital") != -1) { //预约挂号
                monitor_city = $(".J_Menu_Link span").text();
            }
            if ($("#J_SearchBox").attr("monitor") == "sp_search") { //专家问诊
                monitor = "search_query";
            }

            if (!list || !list.length) {
                return;
            }
            $('.J_HistoryList').hide();
            $('#J_SearchAddress').hide();
            $('#J_SearchHot').hide();
            var buf = [];
            for (var i = 0; i < list.length; i++) {
                //埋点上报放在click事件中了,lize
                // buf.push('<li monitor="' + monitor + '" monitor-search-q="' + list[i].name + '" monitor-click-rank="' + i + '" monitor-searchRad="" monitor-city="' + monitor_city + '">' + list[i].name + '</li>');
                buf.push('<li monitor-search_input="'+$('#J_Keyword').val()+'" monitor-search_q="'+list[i].name+'" monitor-click_rank="'+i+'" monitor="weiyiclass_search_ideapad_ideapad"  data-city="'+monitor_city+'">' + list[i].name + '</li>'); 
            }
            $('.J_SuggestList').show().find('ul').empty().append(buf.join(''));
            this.scroll.refresh();
        },
        /**
         * 处理最新输入的搜索词
         * @return {[type]} [description]
         */
        callbackAdjust: function(latest, callback) {
            var $list = $('.J_HistoryList ul');
            if (latest !== undefined) {
                // 如果最新的搜索词不在历史记录中，则需要插入到最前面
                if (latest === '' || this.isInHistory(latest)) {
                    // 为空则删除临时记录项
                    $list.find('li[data-temp]').remove();
                } else {
                    latest = $GH.filterXSS(latest);
                    if ($list.find('li[data-temp]').length) {
                        // 如果已有临时记录项，则修改
                        $list.find('li[data-temp]').html(latest);
                    } else {
                        // 否则在最前面插入
                        $list.prepend('<li data-temp="1">' + latest + '</li>');
                    }
                }
                $('.J_HistoryList').show();
                $('#J_SearchAddress').show();
                $('#J_SearchHot').show();
            }
            if ($list.find('li').length - $list.find('li[data-temp]').length > 0) {
                // 已有的历史记录条数大于0时才显示清除历史记录按钮
                $('.J_ClearHistory').show();
            } else {
                $('.J_ClearHistory').hide();
            }
            if (typeof callback === 'function') {
                callback();
            }
            this.scroll.refresh();
        },
        /**
         * 显示搜索历史
         * @param  {[type]}   latest   最新的搜索词
         * @param  {Function} callback 回调方法
         */
        showHistory: function(latest, callback) {
            var me = this;
            $('.J_SuggestList').hide();
            // 如果有缓存，则使用缓存
            if (this.cacheHistory.length) {
                this.callbackAdjust(latest, callback);
                return;
            }
            var history;
            try {
                var ls = window.localStorage;
                history = ls.getItem('searchHistory');
                history = JSON.parse(history);
            } catch (e) {
                this.callbackAdjust(latest, callback);
                return;
            }
            if (!history || !history.length) {
                // 无历史记录
                this.callbackAdjust(latest, callback);
                return;
            }
            this.cacheHistory = history;
            //打点
            var href = window.location.href;
            var monitor_city = "";
            if (href.indexOf("/fastorder/hospital") != -1) {
                monitor_city = $(".J_Menu_Link span").text();
            }

            var buf = [];
            var show = [];
            for (var i = 0; i < history.length; i++) {
                if ($.inArray(history[i], show) > -1) {
                    continue;
                }
                var item = history[i];
                item = $GH.filterXSS(item);
                //埋点上报放在click事件中了，lize
                // buf.push('<li monitor="search_query" monitor-search-q="' + item + '" monitor-click-rank="' + i + '"monitor-searchRad="" monitor-city="' + monitor_city + '">' + item + '</li>');
                buf.push('<li monitor-click_rank="'+i+'" monitor="weiyiclass_search_active_history" monitor-search_q="'+item+'" data-city="'+monitor_city+'">' + item + '</li>');
                show.push(history[i]);

            }
            $('.J_HistoryList').show().find('ul').append(buf.join(''));
            this.scroll.refresh();
            this.callbackAdjust(latest, callback);
        },
        /**
         * 新增搜索历史
         * @param {[type]} newValue [description]
         */
        addHistory: function(newValue, callback) {
            if (!newValue) {
                return;
            }
            var ls = window.localStorage;
            if (!ls) {
                /*$GH.alert('当前环境不支持保存搜索历史', '', function() {
                    callback();
                });*/
                callback();
                return;
            }
            var history = ls.getItem('searchHistory');
            if (!history) {
                history = [];
            } else {
                history = JSON.parse(history);
            }

            // 兼容老用户
            function unique(arr) { // 去重
                var result = [],
                    hash = {};
                for (var i = 0, elem;
                    (elem = arr[i]) != null; i++) {
                    if (!hash[elem]) {
                        result.push(elem);
                        hash[elem] = true;
                        if (result.length == 7) {
                            break;
                        }
                    }
                }
                return result;
            }
            history = unique(history);

            // 最多显示7个
            if ($.inArray(newValue, history) == -1) {
                if (history.length == 7) {
                    history.pop();
                }
                history.unshift(newValue);
            }
            try {
                ls.setItem('searchHistory', JSON.stringify(history));
                // 历史保存后，跳转到搜索结果页面
                callback();
            } catch (e) {
                callback();
                // safari无痕浏览不支持localStorage
                /*$GH.alert('您处于无痕浏览，无法为您保存搜索历史', '' , function(){
                    callback();
                });*/
            }
        },
        /**
         * 清除搜索历史
         * @return {[type]} [description]
         */
        clearHistory: function() {
            var ls = window.localStorage;
            if (!ls) {
                //$GH.alert('当前环境不支持保存搜索历史');
                return;
            }
            ls.removeItem('searchHistory');
            $('.J_HistoryList').hide().find('ul').empty();
        }
    };

    // if ($("#J_SearchEmbed").length > 0) {
        Main.init();
    // }
    
})();
